<?php
/**
 *
 * @category        snippets
 * @package         socialBaker
 * @author          Ruud Eisinga - http://www.dev4me.nl/modules-snippets/opensource/socialbaker/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @version         2.3
 * @lastmodified    Date: 2015-10-03
 *
 */
/* -------------------------------------------------------- */

// Must include code to stop this file being access directly
if(defined('WB_PATH') == false) { die("Cannot access this file directly"); }

global $socialDefaults, $followDefaults;

$locale['EN'] = "en_US";
$locale['NL'] = "nl_NL";
$locale['DE'] = "de_DE";
$locale['FR'] = "fr_FR";
$locale['IT'] = "it_IT";

$socialDefaults['twitter'] = array (
		'id' 		=> 1,
		'name' 		=> 'Twitter',
		'share' 	=> 'https://twitter.com/intent/tweet?url={URL}&text={STATUS} - {DESCRIPTION}',
		'icon' 		=> 'twitter.png'
	);
$socialDefaults['facebook'] = array (
		'id' 		=> 2,
		'name' 		=> 'Facebook',
		'share' 	=> 'https://www.facebook.com/sharer/sharer.php?u={URL}',
		'icon' 		=> 'facebook.png'
	);
$socialDefaults['googleplus'] = array (
		'id' 		=> 3,
		'name' 		=> 'GooglePlus',
		'share' 	=> 'https://plus.google.com/share?url={URL}',
		'icon' 		=> 'googleplus.png'
	);
$socialDefaults['linkedin'] = array (
		'id' 		=> 4,
		'name' 		=> 'LinkedIn',
		'share' 	=> 'https://www.linkedin.com/shareArticle?mini=true&url={URL}&title={STATUS}&summary={DESCRIPTION}&source=',
		'icon' 		=> 'linkedin.png'
	);

$socialDefaults['digg'] = array (
		'id' 		=> 5,
		'name' 		=> 'Digg',
		'share' 	=> 'http://www.digg.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'digg.png'
	);
	
$socialDefaults['stumbleupon'] = array (
		'id' 		=> 6,
		'name' 		=> 'StumbleUpon',
		'share' 	=> 'http://www.stumbleupon.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'stumbleupon.png'
	);
	
$socialDefaults['delicious'] = array (
		'id' 		=> 7,
		'name' 		=> 'Delicious',
		'share' 	=> 'https://delicious.com/save?v=5&noui&jump=close&url={URL}&title={STATUS}',
		'icon' 		=> 'delicious.png'
	);
$socialDefaults['vk'] = array (
		'id' 		=> 8,
		'name' 		=> 'VKontakte',
		'share' 	=> 'http://vk.com/share.php?url={URL}&title={STATUS}',
		'icon' 		=> 'vk.png'
	);
$socialDefaults['reddit'] = array (
		'id' 		=> 9,
		'name' 		=> 'Reddit',
		'share' 	=> 'http://www.reddit.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'reddit.png'
	);
$socialDefaults['tumblr'] = array (
		'id' 		=> 10,
		'name' 		=> 'Tumblr',
		'share' 	=> 'http://www.tumblr.com/share?v=3&u={URL}&t={STATUS}',
		'icon' 		=> 'tumblr.png'
	);
	
	


function socialBaker($status = null, $imagePath = null, $shares = null) {
	global $socialDefaults, $wb;
	$url = 'http'.($_SERVER['SERVER_PORT'] == 443 ? 's' : '') . '://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
	$description = $wb->page_description;
	$image = '';
	if(!$status) $status = page_status(); 			// if no status (message) is set use Pagetitle
	if(is_array($status)) {
		if(isset($status['url'])) $url = $status['url'];
		if(isset($status['image'])) $image = $status['image'];
		if(isset($status['description'])) $description = $status['description'];
		if(isset($status['status'])) $status = $status['status']; else $status = PAGE_TITLE;
	}
	if(!$imagePath) $imagePath = WB_URL.'/modules/socialbaker/images/'; // if imagePath is not set, use internal icons
	
	if(!$shares) $shares = $socialDefaults; 	// if shares are not set, use all..
	if(!is_array($shares)) $shares = explode(",",$shares);
			
	$retval = '<div class="socialwrapper">';
	foreach ( $shares as $share ) {
		if(!is_array($share)) { 				//element is just a string or number.. find default values..
			if (is_numeric($share)) {
				foreach ($socialDefaults as $tmp) {
					if($tmp['id'] == $share) {
						$share = $tmp;
						break;
					}
				}
			} elseif(is_string($share)) { 			//element is string, just use it as index of the defaults array
				if(isset($socialDefaults[strtolower($share)])) {
					$share = $socialDefaults[strtolower($share)];
				}
			} 
		}
		if(is_array($share)) {
			$share['share'] = str_ireplace('{URL}',urlencode($url),$share['share']);
			$share['share'] = str_ireplace('{IMAGE}',urlencode($image),$share['share']);
			$share['share'] = str_ireplace('{DESCRIPTION}',urlencode($description),$share['share']);
			$share['share'] = str_ireplace('{STATUS}',urlencode($status),$share['share']);
			$retval .= '<div class="socialbaker"><a class="share '.strtolower($share['name']).'" title="'.$share['name'].'" href="'.$share['share'].'"><img class="shareicon" src="'.$imagePath.$share['icon'].'" alt="'.$share['name'].'" /></a></div>'.PHP_EOL;
		}
	}
	$retval .= '</div>';
	return $retval;
}



// FollowBaker

$followDefaults['twitter'] = array (
	'title' 	=> 'Follow us on Twitter',
	'link' 		=> 'https://twitter.com/{ACCOUNT}',
	'icon' 		=> 'twitter.png'
);
$followDefaults['facebook'] = array (
	'title' 	=> 'Follow us on Facebook',
	'link' 		=> 'https://www.facebook.com/{ACCOUNT}',
	'icon' 		=> 'facebook.png'
);
$followDefaults['googleplus'] = array (
	'title' 	=> 'Follow us on Google',
	'link' 		=> 'https://plus.google.com/{ACCOUNT}',
	'icon' 		=> 'googleplus.png'
);
$followDefaults['linkedin'] = array (
	'title' 	=> 'LinkedIn',
	'link' 		=> 'https://linkedin.com/in/{ACCOUNT}',
	'icon' 		=> 'linkedin.png'
);

$followDefaults['vk'] = array (
	'title' 	=> 'Follow us on VK',
	'link' 		=> 'https://www.vk.com/{ACCOUNT}',
	'icon' 		=> 'vk.png'
);


$followDefaults['youtube'] = array (
	'title' 	=> 'YouTube',
	'link' 		=> 'http://youtube.com/user/{ACCOUNT}',
	'icon' 		=> 'youtube.png'
);

$followDefaults['vimeo'] = array (
	'title' 	=> 'Vimeo',
	'link' 		=> 'http://vimeo.com/{ACCOUNT}',
	'icon' 		=> 'vimeo.png'
);

$followDefaults['instagram'] = array (
	'title' 	=> 'Instagram',
	'link' 		=> 'http://instagram.com/{ACCOUNT}',
	'icon' 		=> 'instagram.png'
);

$followDefaults['pinterest'] = array (
	'title' 	=> 'Pinterest',
	'link' 		=> 'http://pinterest.com/{ACCOUNT}',
	'icon' 		=> 'pinterest.png'
);

$followDefaults['flickr'] = array (
	'title' 	=> 'Flickr',
	'link' 		=> 'http://flickr.com/photos/{ACCOUNT}',
	'icon' 		=> 'flickr.png'
);


function followBaker($follows = null, $imagePath = null) {
	global $followDefaults;
	if(!$imagePath) $imagePath = WB_URL.'/modules/socialbaker/images/'; // if imagePath is not set, use internal icons
	$retval = '<div class="followwrapper">';
	foreach ( $follows as $follow => $account ) {
		if($data = $followDefaults[$follow]) {
			$data['link'] = str_ireplace('{ACCOUNT}',$account , $data['link']);
			$retval .= '<div class="followbaker"><a target="_blank" class="follow '.strtolower($follow).'" title="'.$data['title'].'" href="'.$data['link'].'"><img class="followicon" src="'.$imagePath.$data['icon'].'" alt="'.$data['title'].'" /></a></div>'.PHP_EOL;
		}
	}
	$retval .= '</div>';
	return $retval;
}

function shareBaker($shares = null) {
	return socialBaker(null,null,$shares);
}


function openGraph($use_short = false) {
	$settings = _get_page_settings(); // get page/news/bakery settings

	$retval = '';

	if($settings['homepage']) {
		$settings['link'] = '';
		$settings['page_link'] = WB_URL;
	}

	//canonical link
	if($use_short) {
		$retval .= "".'<link rel="canonical" href="'.WB_URL.$settings['link'].'/" />';
	} else {
		$retval .= "".'<link rel="canonical" href="'.$settings['page_link'].'" />';
	}
	
	//facebook and google+ stuff
	$retval .= "\n\t".'<meta property="og:title" content="'.$settings['title'].'" />';
	$retval .= "\n\t".'<meta property="og:description" content="'.$settings['description'].'" />';
	$retval .= "\n\t".'<meta property="og:site_name" content="'.$settings['site_name'].'" />';
	$retval .= "\n\t".'<meta property="og:type" content="'.$settings['type'].'" />';
	$retval .= "\n\t".'<meta property="og:locale" content="'.$settings['locale'].'" />';
	if($use_short) {
		$retval .= "\n\t".'<meta property="og:url" content="'.WB_URL.$settings['link'].'/" />';
	} else {
		$retval .= "\n\t".'<meta property="og:url" content="'.$settings['page_link'].'" />';
	}
	if($image = _get_page_image($settings)) {
		$retval .= "\n\t".'<meta property="og:image" content="'.$image['url'].'" />';
		$retval .= "\n\t".'<meta property="og:image:width" content="'.$image['width'].'" />';
		$retval .= "\n\t".'<meta property="og:image:height" content="'.$image['height'].'" />';
	}
	//twitter stuff
	$cardtype = ($image && $image['width'] > 250) ? "summary_large_image":"summary";
	$retval .= "\n\t".'<meta name="twitter:card" content="'.$cardtype.'" />';
	$retval .= "\n\t".'<meta name="twitter:site" content="'.$settings['site_name'].'"/>';
	$retval .= "\n\t".'<meta name="twitter:title" content="'.$settings['title'].'"/>';
	$retval .= "\n\t".'<meta name="twitter:description" content="'.$settings['description'].'"/>';
	if($use_short) {
		$retval .= "\n\t".'<meta name="twitter:url" content="'.WB_URL.$settings['link'].'"/>';
	} else {
		$retval .= "\n\t".'<meta name="twitter:url" content="'.$settings['page_link'].'" />';
	}
	if($image) {
		$retval .= "\n\t".'<meta name="twitter:image" content="'.$image['url'].'"/>';
		$retval .= "\n\t".'<meta name="twitter:image:width" content="'.$image['width'].'" />';
		$retval .= "\n\t".'<meta name="twitter:image:height" content="'.$image['height'].'" />';
	}
	$retval .= "\n";
	return $retval;
}


function page_status() {
	global $database,$post_id,$item_id;
	if(isset($post_id )) {
		$title = $database->get_one("SELECT `title` from ".TABLE_PREFIX."mod_news_posts WHERE `post_id` = '$post_id'");
	} elseif (isset($item_id) || defined('ITEM_ID') ) {
		if(!isset($item_id))$item_id = ITEM_ID;
		$title = $database->get_one("SELECT `title` from ".TABLE_PREFIX."mod_bakery_items WHERE `item_id` = '$item_id'");	
	} else {
		$title = PAGE_TITLE;
	}
	return $title;
}

function _get_page_settings() {
	global $wb, $database, $locale, $post_id, $item_id, $topic_id;
	if(isset($post_id)) {
		$page = $database->query("SELECT *, link as menu_title, content_short as description FROM " . TABLE_PREFIX . "mod_news_posts WHERE `post_id`='".$post_id."'");
	} elseif(isset($topic_id) && file_exists(WB_PATH.'/modules/topics/module_settings.php')) {
		require(WB_PATH.'/modules/topics/module_settings.php');
		$page = $database->query("SELECT *, link as menu_title FROM " . TABLE_PREFIX . "mod_topics WHERE `topic_id`='".$topic_id."'");
	} elseif(isset($item_id)) {
		$page = $database->query("SELECT *, link as menu_title FROM " . TABLE_PREFIX . "mod_bakery_items WHERE `item_id`='".$item_id."'");
	} else {		
		$page = $database->query("SELECT *, page_title as title FROM ".TABLE_PREFIX."pages WHERE `page_id` = '".PAGE_ID."'");
	}
	$settings = $page->fetchRow();
	$settings['homepage'] = $wb->default_page_id == PAGE_ID;
	$settings['description'] = trim(strip_tags($settings['description']));
	$settings['site_name'] = WEBSITE_TITLE;
	$settings['type'] = 'website';
	if(!isset($settings['language'])) $settings['language'] = LANGUAGE;
	$settings['locale'] = isset($locale[$settings['language']])?$locale[$settings['language']]:strtolower($settings['language']).'_'.$settings['language'];
	$settings['page_link'] = $wb->page_link($settings['link']);
	if(isset($topic_id)) {
		$settings['page_link'] = htmlspecialchars(WB_URL.$topics_directory.$settings['link'].PAGE_EXTENSION);
		$settings['description'] = trim(strip_tags($settings['content_short']));
	}
	return $settings;
}
function _get_page_image($settings = array()) {
	global $database, $topic_id, $post_id;
	$menu_title = $settings['menu_title'];
	$retval = array();
	if(isset($topic_id)) {
		$picture_dir = $database->get_one("SELECT `picture_dir` FROM ".TABLE_PREFIX."mod_topics_settings WHERE page_id = '".PAGE_ID."'");
		$retval['filename'] = WB_PATH.$picture_dir.'/'.$settings['picture'];
		$retval['url'] = WB_URL.$picture_dir.'/'.$settings['picture'];
	} elseif(isset($post_id) && file_exists(WB_PATH.MEDIA_DIRECTORY.'/posts/'.$post_id.'.jpg')) {
		$retval['filename'] = WB_PATH.MEDIA_DIRECTORY.'/posts/'.$post_id.'.jpg';
		$retval['url'] = WB_URL.MEDIA_DIRECTORY.'/posts/'.$post_id.'.jpg';
	} elseif(file_exists(WB_PATH.MEDIA_DIRECTORY.'/pages/'.PAGE_ID.'.jpg')) {
		$retval['filename'] = WB_PATH.MEDIA_DIRECTORY.'/pages/'.PAGE_ID.'.jpg';
		$retval['url'] = WB_URL.MEDIA_DIRECTORY.'/pages/'.PAGE_ID.'.jpg';
	} elseif(file_exists(WB_PATH.MEDIA_DIRECTORY.'/pages/'.$menu_title.'.jpg')) {
		$retval['filename'] = WB_PATH.MEDIA_DIRECTORY.'/pages/'.$menu_title.'.jpg';
		$retval['url'] = WB_URL.MEDIA_DIRECTORY.'/pages/'.$menu_title.'.jpg';
	} elseif(file_exists(WB_PATH.MEDIA_DIRECTORY.'/pages/website.jpg')) {
		$retval['filename'] = WB_PATH.MEDIA_DIRECTORY.'/pages/website.jpg';
		$retval['url'] = WB_URL.MEDIA_DIRECTORY.'/pages/website.jpg';
	} 

	if(!count($retval)) return false;
	list($width, $height) = getimagesize($retval['filename']);
	$retval['width'] = $width;
	$retval['height'] = $height;
	return $retval;
}



?>
